﻿///<reference path="jquery-1.6.1-vsdoc.js" />
(function (window, $) {
    //iphone版本
    var isIPhone = (/iphone/gi).test(navigator.appVersion);
    if (isIPhone) {
        window.WebApi = {};
        window._iframeforiphone = document.createElement("iframe");
        window._iframeforiphone.style.display = "none";
        var _aDiv = $("body").append(window._iframeforiphone).find(">div");
        if (_aDiv.length > 0) {
            _aDiv[0].addEventListener("click", function () { }, false);
        }

        var _send = function (method, ags) {
            ags = ags || {};
            ags["WebApi"] = method;
            window._iframeforiphone.src = "/?" + $.param(ags);
        };
        window.iphoneInit = function (netstat, imei) {
            window._network = val;
            window._imei = val;
        }
        _send("iphoneInit"); //获取初始化数据

        $.extend(window.WebApi, {
            showLoadingProgress: function () { _send("showLoadingProgress"); },
            hideLoadingProgress: function () { _send("hideLoadingProgress"); },
            ShowInfo: function (val) { _send("ShowInfo", { msg: val }); },
            onSingleTapUp: function () { _send("onSingleTapUp"); },
            getImei: function () { return window._imei; },
            NetWork: function () { return window._network; },
            Collected: function (val) { _send("Collected", { val: val }); },
            phoneNum: function (val) { _send("phoneNum", { val: val }); },
            ForContent: function (num, url) { _send("ForContent", { num: num, url: url.replace(/&/g, "@") }); },
            Comment0: function (parentid, cb) { _send("Comment0", { parentid: parentid, cb: cb }); },
            Comment1: function (parentid, cb) { _send("Comment1", { parentid: parentid, cb: cb }); },
            DownPic: function (url, filename, current, total, isEnd) {
                _send("DownPic", { url: url, file: filename, current: current, total: total, isEnd: isEnd ? 1 : 0 });
            },
            closeActivity: function () { _send("closeActivity"); },
            Attentioned: function (val, count) { _send("Attentioned", { val: val, count: count }); },
            Weather: function (city, temperature, carwash, picurl) {
                _send("Weather", { city: city, temperature: temperature, carwash: carwash, picurl: picurl });
            },
            WeatherC: function (city, temperature, carwash, picurl) {
                _send("Weather", { city: city, temperature: temperature, carwash: carwash, picurl: picurl });
            },
            SeriesPic: function (id) { _send("SeriesPic", { id: id }); },
            ContentUrl: function (url) { _send("ContentUrl", { url: url.replace(/&/g, "@") }); },
            Select: function (s, m, n) { _send("Select", { data: s, Mode: m, cSize: n }); },
            Share: function (t, id, url, tid, cid) { setTimeout(function () { _send("Share", { t: t, id: id, sharePicPath: url, tid: tid, cid: cid }); }, 1100); },
            LiveRoom: function (nm) { setTimeout(function () { _send("LiveRoom", { nm: nm }); }, 0); },
            LiveRoomNum: function (num) { setTimeout(function () { _send("LiveRoomNum", { num: num }); }, 800); },
            newspush1: function (key) { _send("newspush1", { key: key }); }
        });
    }
    var global = {
        isIPhone: isIPhone,
        R: "http://gon.3g.cn/Interface/"
    }, WebApi = window.WebApi,
    _computerCache = function (name, val) {
        if (val != undefined) {
            val = typeof val != "string" ? JSON.stringify(val) : val;
            localStorage[name] = val;
        } else {
            return localStorage[name] || "";
        }
    },
    localCache = WebApi && WebApi.GetCache ? function (name, val) {
        //web本地存储
        if (!/[A-Z]/.test(name)) {
            name = name.toUpperCase();
        }
        if (arguments.length >= 2 && WebApi && WebApi.SetCache) {
            val = typeof val != "string" ? JSON.stringify(val) : val;
            WebApi.SetCache(name, val);
        } else {
            return String((WebApi && WebApi.GetCache) ? WebApi.GetCache(name) : "");
        }
    } : function (name, val) { return _computerCache(name, val) },
    dbCache = WebApi && WebApi.GetFromDb ? function (name, val, flag) {
        //内存卡存储
        if (!/[A-Z]/.test(name)) {
            name = name.toUpperCase();
        }
        if (arguments.length >= 2 && WebApi) {
            val = typeof val != "string" ? JSON.stringify(val) : val;
            if (flag == true || (flag == "check" && (WebApi.ExistInDb && WebApi.ExistInDb(name)))) {
                WebApi.UpToDb && WebApi.UpToDb(name, val);
            } else {
                WebApi.SetToDb && WebApi.SetToDb(name, val);
            }
        } else {
            return String((WebApi && WebApi.GetFromDb) ? WebApi.GetFromDb(name) : "");
        }
    } : function (name, val) { return _computerCache(name, val) };

    function parseTpl(tpl, data) {
        return tpl.replace(/\{\$(\w+)\}/g, function ($0, $1) {
            return data[$1];
        });
    }

    function parseTplByFunc(tpl, data) {
        if (null == tpl) { return; }
        if (null == data) { return tpl; }
        var fn = new Function("obj", "var _=[];_.push('" +
				tpl.replace(/[\r\t\n]/g, " ")
				.replace(/'(?=[^#]*#>)/g, "\t")
				.split("'").join("\\'")
				.split("\t").join("'")
				.replace(/<#=(.+?)#>/g, function (_, k) {
				    return "',!obj." + k + "&&obj." + k + "!==0?'':obj." + k + ",'";
				})
				.split("<#").join("');")
				.split("#>").join("_.push('")
				+ "');return _.join('');");
        return fn(data);
    }

    function showInfo(message) {
        if (WebApi && WebApi.ShowInfo) {
            WebApi.ShowInfo(message);
        } else {
            console && console.log(message);
        }
    }

    $.extend(global, {
        testMsg: showInfo,
        showInfo: showInfo,
        cache: localCache,
        dbCache: dbCache,
        parseTpl: parseTpl,
        parseTplByFunc: parseTplByFunc,
        open: open,
        WebApi: WebApi,
        netStatus: (WebApi && WebApi.NetWork) ? parseInt(WebApi.NetWork()) : 1,
        imei: (function () { return WebApi && WebApi.getImei ? WebApi.getImei() : ""; })(),
        userAgent: window.navigator.userAgent.toLowerCase(),
        ftype: /[?&]t=(\d+)/i.test(location.href) ? RegExp.$1 : -1,
        stype: /[?&]st=(-?\d+)/i.test(location.href) ? RegExp.$1 : 0,
        fadeIn: function (t, cb) { $(t).fadeIn(600, cb); },
        query: (function () { var r = {}; location.href.replace(/(?:\?|&)([^\s=&]+)=([^\s=&#]*)/g, function (_, k, v) { r[k] = v; }); return r; })(),
        to404: function () {
            if (WebApi && WebApi.nopageBgDisp) { WebApi.nopageBgDisp(); }
            else {
                location.href = isIPhone ? "404.html" : "file:///android_asset/404.html?url=" + encodeURIComponent(location.href);
            }
        },
        shutter: function (list, cb) {
            //鉴于性能需要 只对前6个进行效果
            var item = list.shift();
            if (item) {
                var temp = $(item);
                global._shutternum = global._shutternum ? global._shutternum + 1 : 1;
                if (global._shutternum < 7) {
                    temp.slideDown(200, function () {
                        global.shutter(list, cb);
                    });
                } else {
                    temp.show();
                    $.each(list, function () { $(this).show(); });
                    global._shutternum = undefined;
                    global.shutter([], cb);
                }
            } else if ($.isFunction(cb)) {
                cb();
            }
        },
        weatherConvert: function (des) {
            var date = new Date().getHours(), icon;
            des = des.split("~");
            des = (date >= 17) ? des[1] : des[0];
            if (des.indexOf("雨") != -1)
                return "rain.png";
            else if (des.indexOf("雪") != -1)
                return "snow.png";

            switch (des) {
                case "阴": return "dark_cloud.png";
                case "晴": return (date >= 17) ? "sun_night.png" : "sun.png";
                case "雾": return "fog.png";
                default: return (date >= 17) ? "cloud_night.png" : "cloud.png";
            }
        },
        int: function (val, def) {
            try {
                return parseInt(val || def);
            } catch (e) { return def || 0; }
        },
        emptyFun: function () { return true; },
        status: { Cache: 0, Latest: 1, First: 2, Nextpage: 3, Preload: 4 }, //请求状态
        close: function () {
            if (WebApi && WebApi.closeActivity)
                WebApi.closeActivity();
            else
                window.close();
        }
    });

    //404跳转检查

    if (global.netStatus == 0) {
        var href = location.href.toLowerCase(), redMark = true,
         er = ["news/index.html", "news/newscontent.html", "/init.html", "/setting.html", "news/newslist.html"];
        for (var i = er.length - 1; i >= 0; i--) {
            if (href.indexOf(er[i]) != -1) {
                redMark = false;
                break;
            }
        }
        if (redMark) {
            global.to404();
        }
    }

    $.fn.extend({
        swipe: function (leftFunc, rightFunc) {
            var $this = this, win = window, WA = WebApi;
            //客户端注册事件 2.1不支持 所以需要调用客户端接口
            if (WA && WA.Swipe) {
                win.swipeLeft = function () {
                    leftFunc.call($this);
                };
                win.swipeRight = function () {
                    rightFunc.call($this);
                };
                WA.Swipe("swipeLeft", "swipeRight");
                return;
            }
            if ("ontouchstart" in document.body) {
                var touchStartEvent = "touchstart", touchStopEvent = "touchend", touchMoveEvent = "touchmove", scrollEvent = "scroll";
            }
            else {
                var touchStartEvent = "mousedown", touchStopEvent = "mouseup", touchMoveEvent = "mousemove", scrollEvent = "scroll";
            }
            $this.bind(touchStartEvent, function (event) {
                var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event,
					start = {
					    time: (new Date).getTime(),
					    coords: [data.pageX, data.pageY],
					    origin: $(event.target)
					},
                    stop;
                function moveHandler(event) {
                    if (!start) {
                        return;
                    }
                    var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event;
                    stop = {
                        time: (new Date).getTime(),
                        coords: [data.pageX, data.pageY]
                    };

                    if (Math.abs(start.coords[0] - stop.coords[0]) > 10) {
                        event.preventDefault();
                        //moveEnd(event);
                    }
                }
                function moveEnd(event) {
                    if (start && stop) {
                        if (stop.time - start.time < 1000 &&
									Math.abs(start.coords[0] - stop.coords[0]) > 30 &&
									Math.abs(start.coords[1] - stop.coords[1]) < 75) {

                            $this.unbind(touchMoveEvent, moveHandler);
                            if (start.coords[0] > stop.coords[0] && $.isFunction(leftFunc))
                                leftFunc.call($this);
                            else if (start.coords[0] <= stop.coords[0] && $.isFunction(rightFunc)) {
                                rightFunc.call($this);
                            }
                        }
                        start = stop = undefined;
                    }
                }
                $this.bind(touchMoveEvent, moveHandler).one(touchStopEvent, moveEnd);
            });
            return $this;
        },
        hover: function (overClass) { //手势悬停 2.1touchend事件触发不灵敏 需要注册touchmove
            var r = RegExp("(?:^|\\s*)" + overClass + "(?=\\s|$)", "g");
            if ("ontouchstart" in document.body) {
                var touchStartEvent = "touchstart", touchStopEvent = "touchend", touchMoveEvent = "touchmove", scrollEvent = "scroll";
            }
            else {
                var touchStartEvent = "mousedown", touchStopEvent = "mouseup", touchMoveEvent = "mousemove", scrollEvent = "scroll";
            }
            this.live(touchStartEvent, function (event) {
                $("." + overClass).removeClass(overClass);
                var cName = this.className;
                this.className = cName + " " + overClass;
                event.stopPropagation && event.stopPropagation();
            });
            this.live(touchMoveEvent, function () {
                var _this = this, cName = _this.className;
                _this.className = cName.replace(r, "");
            });
            this.live(touchStopEvent, function () {
                var _this = this, cName = _this.className;
                if (r.test(cName)) {
                    setTimeout(function () {
                        cName = _this.className;
                        _this.className = cName.replace(r, "");
                    }, 0);
                }
            });

            var overClassAry = window._overClassAry || [], overClassExp = "." + overClassAry.join(",.");
            if (!RegExp("." + overClass + "(?=,|$)", "g").test(overClassExp)) {
                overClassAry.push(overClass);
                document["on" + scrollEvent] = function () {
                    $("." + overClassAry.join(",.")).removeClass(overClassAry.join(","));
                };
            }
            return this;
        }
    });



    //重写跨域getJSON方法，使之支持超时机制
    //重写：JSONP回调方法，url转CDN方式

    var _getJSON = $.getJSON, _timeout = 60 * 1000, nMark = false;

    $.getJSONnoCDN = function (url, data, success, fail) {
        if (fail === null) { //强制不需要超时
            _getJSON(url, data, success);
            return;
        }
        $.ajax({
            url: url,
            data: data,
            dataType: 'json',
            timeout: _timeout,
            success: success,
            error: fail ? fail : function (e) {
                if (!nMark && e.statusText == "timeout") {
                    nMark = true;
                    if (WebApi && WebApi.nopageBgDisp) { WebApi.nopageBgDisp(); }
                    else { global.showInfo("您的网络不稳定，请稍后再试"); }
                } else if (e.statusText.indexOf("error") != -1) {
                    if (WebApi && WebApi.nopageBgDisp) { WebApi.nopageBgDisp(); }
                    else { global.showInfo("您的网络不稳定，请稍后再试"); }
                }
                var WebApi = window.WebApi;
                WebApi && WebApi.hideLoadingProgress && WebApi.hideLoadingProgress();
            }
        });
    }

    var head = document.head || document.getElementsByTagName("head")[0] || document.documentElement;
    $.getJSON = function (url, data, success, fail) {
        //重写jsonp
        var jsonp = {
            url: url || "",
            _pData: data || {},
            _url: "",
            _cbName: "",
            _cb: function (cb) {
                var _this = this, script = this._script;
                this._cbName = cb;
                window[cb] = function (data) {
                    if (head && script && script.parentNode) {
                        head.removeChild(script);
                        script = null;
                    }
                    if (_this._timeOutON) {
                        if (_this._timeIsOut) {
                            return;
                        }
                        clearTimeout(_this._timeOuter);
                    }
                    var typeName = typeof data;
                    if (typeName == "object") {
                        _this._success(data);
                    }
                    else if (typeName == "string") {
                        data = $.parseJSON(data);
                        if (typeof data == "object") {
                            _this._success(data);
                        }
                        else {
                            _this._error({ statusText: "error:数据格式错误" });
                        }
                    }
                    else if (data instanceof Array) {
                        _this._success({ _: data });
                    }
                    else {
                        _this._error({ statusText: "error:错误" });
                    }
                };
            },
            _urlTrans: function () {
                var _this = this, url = this.url, fields = [], url_ = "", p = {};
                url.replace(/(.+?)\/Interface\/(.+?)\?(.+)$/i, function (_, $1, $2, $3) {
                    fields.push($1);
                    url_ = $2;
                    $3.replace(/(?:^|&)(.+?)=(.*?)(?:&|$)/g, function (_, k, v) { p[k] = v; });
                });

                for (var i in p) {
                    fields.push(i, p[i]);
                }
                for (var j in data) {
                    fields.push(j, data[j]);
                }
                fields.push("Interface", url_);
                url = fields.join("/").replace(/^(.+?)\/cb\/\?(.*)$/i, function (_, $1, $2) {
                    var oldUrl = $1 + $2;
                    oldUrl = "_" + encodeURIComponent(oldUrl.substring(7).replace(/[:\/\.]/g, "").replace(/-/g, "_")) + "_";
                    _this._cb(oldUrl);
                    return $1 + "/cb/" + oldUrl + $2;
                });
                this._url = url;
            },
            _timeOutON: fail || false,
            _timeOut: _timeout,
            timeOut: function (t) { this._timeOut = t; return this; },
            _timeOutBack: function () { },
            _timeOuter: null,
            _timeIsOut: false,
            _script: null,
            send: function () {
                var _this = this;
                if (this.url == "") { return; }
                this._urlTrans();
                var script = document.createElement("script");
                script.type = "text/javascript";
                script.src = this._url;
                head.appendChild(script);
                if (this._timeOutON) {
                    this._timeOuter = setTimeout(function () {
                        _this._timeIsOut = true;
                        window[_this._cbName] = function () { };
                        if (head && script && script.parentNode) {
                            head.removeChild(script);
                            script = null;
                        }
                        _this._timeOutBack();
                    }, this._timeOut);
                }
                this._script = script;
            },
            _success: success || function () { },
            _error: function (e) {
                if (!nMark && e.statusText == "timeout") {
                    nMark = true;
                    if (WebApi && WebApi.nopageBgDisp) { WebApi.nopageBgDisp(); }
                    else { global.showInfo("您的网络不稳定，请稍后再试"); }
                } else if (e.statusText.indexOf("error") != -1) {
                    if (WebApi && WebApi.nopageBgDisp) { WebApi.nopageBgDisp(); }
                    else { global.showInfo("您的网络不稳定，请稍后再试"); }
                }
                var WebApi = window.WebApi;
                WebApi && WebApi.hideLoadingProgress && WebApi.hideLoadingProgress();
            }
        };
        jsonp.send();
    };

    //初始化操作
    $(function () {
        $.extend(global, { config: {
            mode: function (val) {  //白天/夜间模式 2夜间模式 其他 白天
                var key = "mediaclient_mode";
                return val ? localCache(key, val) : global.int(localCache(key), 1);
            },
            update: function (val) { //更新方式 2wifi可用时  3关闭
                var key = "mediaclient_update";
                return val ? localCache(key, val) : global.int(localCache(key), 2)
            },
            size: function (val) {  //字体大小 1大 3小 其他 中
                var key = "mediaclient_size";
                return val ? localCache(key, val) : global.int(localCache(key), 2)
            }
        }
        });
    });

    window.global = global;
    window.onReload = function () { };
    window.winHeight = document.documentElement.clientHeight;
    window.winWidth = document.documentElement.clientWidth;
    $(".max-Container").css({
        minHeight: window.winHeight,
        maxWidth: window.winWidth
    });
})(window, jQuery);