﻿(function () {
    //xkp mark20110808
    var m = Math,
        $ = function (id) { return document.getElementById(id); },
        hasTouch = 'ontouchstart' in window,
        START_EV = hasTouch ? 'touchstart' : 'mousedown',
	    MOVE_EV = hasTouch ? 'touchmove' : 'mousemove',
	    END_EV = hasTouch ? 'touchend' : 'mouseup',
	    CANCEL_EV = hasTouch ? 'touchcancel' : 'mouseup',
        vendor = (/webkit/i).test(navigator.appVersion) ? 'webkit' :
		    (/firefox/i).test(navigator.userAgent) ? 'Moz' : 'opera' in window ? 'O' : '',
        preventDefault = function (e) { e.preventDefault(); },
        	nextFrame = (function () {
        	    return window.requestAnimationFrame
			|| window.webkitRequestAnimationFrame
			|| window.mozRequestAnimationFrame
			|| window.oRequestAnimationFrame
			|| window.msRequestAnimationFrame
			|| function (callback) { return setTimeout(callback, 1); }
        	})(),
	cancelFrame = (function () {
	    return window.cancelRequestAnimationFrame
			|| window.webkitCancelRequestAnimationFrame
			|| window.mozCancelRequestAnimationFrame
			|| window.oCancelRequestAnimationFrame
			|| window.msCancelRequestAnimationFrame
			|| clearTimeout
	})();

    var scroll = function (scroller) {
        var that = this;
        that.scroller = that.initDom(scroller);
        that.scroller.style[vendor + 'TransitionProperty'] = '-' + vendor.toLowerCase() + '-transform';
        that.scroller.style[vendor + 'TransitionDuration'] = '0';
        that.scroller.style[vendor + 'TransformOrigin'] = '0 0';
        that.scroller.style[vendor + 'Transform'] = 'translate(0px,0px)';
        that.bind(START_EV);
    };
    scroll.prototype = {
        data: {},
        handleEvent: function (e) { //事件句柄注册
            var t = this, type = e.type;
            e = hasTouch ? e.touches[0] : e;
            switch (type) {
                case START_EV:
                    if (!hasTouch && e.button !== 0) return;
                    t.start(e);
                    break;
                case MOVE_EV: t.move(e); break;
                case END_EV:
                case 'webkitTransitionEnd':
                case CANCEL_EV: t.end(e); break;
            }
        },
        bind: function (type, el, bubble) {
            (el || this.scroller).addEventListener(type, this, !!bubble);
        },
        unbind: function (type, el, func, bubble) {
            (el || this.scroller).removeEventListener(type, func || this, !!bubble);
        },
        lockScroll: function () {
            var that = this;
            if (that.lockScrolled === true) return;
            document.addEventListener(MOVE_EV, preventDefault, false);
            that.lockScrolled = true;
        },
        reScroll: function () {
            var that = this;
            if (that.lockScrolled === true) {
                document.removeEventListener(MOVE_EV, preventDefault, false);
                that.lockScrolled = undefined;
            }
        },
        initDom: function (scroller) {
            var that = this, div = document.querySelector("." + scroller),
				css = { position: "absolute", zIndex: "100", left: "0px", top: "0px" };
            for (var c in css) {
                div.style[c] = css[c];
            }
            that.addFresh();
            //document.body.style.position = "relative";
            //document.body.style.backgroundColor = "gray";
            //document.body.style.margin = "0px";
            return div;
        },
        addFresh: function () {
            var that = this,
                div = document.createElement("div"), css = { width: "100%", height: "50px", lineHeight: "50px", textAlign: "center" };
            for (var c in css) {
                div.style[c] = css[c];
            }
            that.scrollIco = document.createElement("img");
            that.scrollIco.src = "../Images/scrollIco.png";
            that.freshText = document.createElement("span");
			that.freshText.innerHTML = "再往下拉刷新";
            div.appendChild(that.scrollIco);
            div.appendChild(that.freshText);
            document.body.appendChild(div);
        },
        rotateIco: function (y) {
            var that = this, ico=that.scrollIco, l = 2;
            l = y / l;
            //scale(" + 2 + ") rotate(10deg) skew(20deg)
            if (y >= 100 && window.dragFresh && !that.__notify) {
                that.__notify = true;
                window.dragFresh.call(that,that);
            }
            ico.style[vendor + 'Transform'] = "rotate(" + l + "deg)";
        },
		resize:function(){
			var that=this;
			that.freshText.innerHTML = "再往下拉刷新";
			that.__notify = undefined;
		},
        start: function (e) {
            var that = this, matrix = getComputedStyle(that.scroller, null)[vendor + 'Transform'].replace(/[^0-9-.,]/g, '').split(',');
            that.data = {
                pointX: e.pageX,
                pointY: e.pageY,
                x: matrix[4] * 1,
                y: matrix[5] * 1
            };

            that._animate && cancelFrame(that._animate);

            that.lockScroll();

            that.bind(MOVE_EV);
            that.bind(END_EV);
            that.bind(CANCEL_EV);
        },
        move: function (e) {
            var that = this,
                scrollMin = document.body.scrollTop,
                scrollHeight = document.body.scrollHeight,
                scrollMax = scrollMin + document.documentElement.clientHeight,
                isDown = (scrollMin == 0 && that.data.pointY < e.pageY),
                isUp = (scrollMax == scrollHeight && that.data.pointY > e.pageY);
            if (!isDown && !isUp) {
				try{
                that.disable = true;

                that.unbind(MOVE_EV); //移除自身事件

                that.reScroll();

				}catch(e){alert(e.message);}
                return;
            }
            var deltaY = e.pageY - that.data.pointY, newY = that.data.y + deltaY;
            that.scroller.style[vendor + 'Transform'] = "translate(0px," + newY + "px) scale(1)";
            that.rotateIco(newY);
        },
        end: function (e) {
            var that = this;
            that.unbind(CANCEL_EV);
            that.data = undefined;
            if (that.disable) {
                that.disable = undefined;
                return;
            }
            that.unbind(MOVE_EV);
            that.reScroll();

            var matrix = getComputedStyle(that.scroller, null)[vendor + 'Transform'].replace(/[^0-9-.,]/g, '').split(',');

            var x = matrix[4] * 1, y = matrix[5] * 1, flag = y / (y = m.abs(y));
            (function slide() {
                var seg = y > 50 ? 50 : y > 20 ? 15 : y > 10 ? 5 : 1;
                y = m.max(0, y - seg);
                that.scroller.style[vendor + 'Transform'] = "translate(0px," + flag * y + "px) scale(1)";
                that.rotateIco(y);
                if (y == 0) {
                    that.resize();
                    //  cancelFrame(that._animate);
                    return;
                } else {
                    // that._animate = nextFrame(slide);
                    slide();
                }
            })();
        }
    }
    window.scroller = scroll;
})();
window.addEventListener("load", function () {
    new window.scroller("max-Container");
}, false);
